% kif0(Z, L0, L): L0-L egy Z aritmetikai kifejezss elemezhet ki
kif0(X+Y) --> tag0(X), "+", !, kif0(Y).
kif0(X-Y) --> tag0(X), "-", !, kif0(Y).
kif0(X) -->   tag0(X).

tag0(X) --> szm(X).            % egyelre

% kif(Z, L0, L): L0 elejn egy Z maximlis aritmetikai kifejezs ll, marad L.
kif(Z) --> tag(X), kifmaradk(X, Z).

% Leelemezhet nulla vagy tbb additv mvelettel megelztt tag, ezek
% egy eddig leelemzett X kifejezssel egytt a Z kifejezst alkotjk.
kifmaradk(X, Z) --> "+", tag(Y), !, kifmaradk(X + Y, Z).
kifmaradk(X, Z) --> "-", tag(Y), !, kifmaradk(X - Y, Z).
kifmaradk(X, X) --> [].

% Leelemezhet egy Z rtk tag.
tag(Z) --> tnyez(X), tagmaradk(X, Z).

% Leelemezhet nulla vagy tbb multiplikatv mvelet s azt kvet tnyez,
% amelyek egy eddig leelemzett X kifejezssel egytt a Z kifejezst alkotjk.
tagmaradk(X, Z) --> "*", tnyez(Y), !, tagmaradk(X*Y, Z).
tagmaradk(X, Z) --> "/", tnyez(Y), !, tagmaradk(X/Y, Z).
tagmaradk(X, X) --> [].

tnyez(X) -->
	(   szm(X)
%	;   "x", {X = x}
%	;   "(", kif(X), ")"
	).

